﻿using GTP.Cloud.RestClient;
using System;
using System.Collections.Generic;
using System.Data;
using System.Windows.Forms;
using Newtonsoft.Json.Linq;

namespace GetBillDemo
{
    public partial class Demo : Form
    {
        private Dictionary<String,String> _lxDic = new Dictionary<String, String>();
        protected RestServiceClient restClient = new RestServiceClient();
        public Demo()
        {
            InitializeComponent();
            this.beginTime.Value = DateTime.Now;
            setLxDic();
            IntiCbLx();
        }

        private void setLxDic()
        {
            _lxDic.Add("获取集成项目信息", "/api/inspection/v1.0/project/getTenantHasCodeProject");
            _lxDic.Add("获取收料单据", "/gys/inspection-api-service/integrate/getSLlist");
            _lxDic.Add("获取发料单据", "/gys/inspection-api-service/integrate/getFLlist");
            _lxDic.Add("获取作废收料单据", "/gys/inspection-api-service/integrate/getSLDeletelist");
            _lxDic.Add("获取作废发料单据", "/gys/inspection-api-service/integrate/getFLDeletelist");
        }

        /// <summary>
        /// 初始化获取磅单类型
        /// </summary>
        private void IntiCbLx()
        {
            DataTable dt = new DataTable();//定义comboxbox1绑定的数据源
            dt.Columns.Add("T");
            dt.Columns.Add("V");

            foreach (String key in _lxDic.Keys) {
                DataRow row = dt.NewRow();
                row["T"] = key;
                row["V"] = _lxDic[key];
                dt.Rows.Add(row);
            }            
            cb_lx.DataSource = dt;
            cb_lx.DisplayMember = "T"; //显示文本
            cb_lx.ValueMember = "V";    //显示文本对应的值
            
        }

        private void button1_Click(object sender, EventArgs e)
        {
            openFileDialog1.InitialDirectory = "";
            openFileDialog1.Filter = "授权文件(*.lic)|*.lic|所有文件(*.*)|*.*";
            openFileDialog1.FilterIndex = 1;
            openFileDialog1.FileName = "";
            openFileDialog1.RestoreDirectory = true;
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                filePath.Text = openFileDialog1.FileName;
                try
                {

                    RestServiceClient.LoadLicense(openFileDialog1.FileName);
                    
                    string hostAddress = RestServiceClient.RestRootAddress;                
                    this.serverAddress.Text = hostAddress; 
                }
                catch (Exception ie)
                {
                    MessageBox.Show(ie.Message);
                }
                          
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {

            string requestUrl = cb_lx.SelectedValue.ToString();
            try
            {
                string url = this.serverAddress.Text + requestUrl+ "?projectId=" + this.projectId.Text;
                url = url + "&beginTimestamp=" + string.Format("{0:yyyyMMddHHmmss}", this.beginTime.Value) ;
                RestResponseInfo restResponseInfo = restClient.Get(url);
                if (restResponseInfo.Success)
                {
                    String str = restResponseInfo.ResponseString;
                    this.billData.Text = JsonUitl.ConvertJsonString(str);
                }
                else {
                    //请求失败:
                    //第11步：拼接完整的上报请求失败地址
                    string faultLogApiURI = "/gys/tl/services/trace/api-fault-log";
                    string faultLogFullURL = this.serverAddress.Text + faultLogApiURI;
                    //第12步：构建上报请求失败数据
                    JObject faultLog = new JObject();
                    faultLog["requestUrl"] = url;
                    faultLog["requestMethod"] = "GET";
                    faultLog["requestBody"] = "";
                    faultLog["statusCode"] = restResponseInfo.ErrorCode;
                    faultLog["response"] = restResponseInfo.ResponseString;
                    faultLog["description"] = restResponseInfo.ErrorMessage;
                    string searchKey = DateTime.Now.ToString("yyyyMMddHHmmss");//时间戳格式，到秒
                    faultLog["searchKey"] = searchKey;  //能表征本次请求记录的标识，方便进行问题排查
                    //第13步：上报请求失败数据
                    restClient.Post(faultLogFullURL, faultLog.ToString());
                    //MessageBox.Show(restResponseInfo.ErrorCode + "  " + restResponseInfo.ErrorMessage);
                }
            }
            catch (Exception ie)
            {
                MessageBox.Show(ie.Message);
            }
        }

        /// <summary>  
        /// DateTime时间格式转换为Unix时间戳格式  
        /// </summary>  
        /// <param name="time"> DateTime时间格式</param>  
        /// <returns>Unix时间戳格式</returns>  
        public static int ConvertDateTimeInt(System.DateTime time)
        {
            System.DateTime startTime = TimeZone.CurrentTimeZone.ToLocalTime(new System.DateTime(1970, 1, 1));
            return (int)(time - startTime).TotalSeconds;
        }

        private void groupBox3_Enter(object sender, EventArgs e)
        {

        }
    }
}
